import javax.microedition.midlet.MIDlet;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;

public class Paranoia extends MIDlet implements CommandListener
{
    private final int MAX_PASSPHRASE_LEN = 50;
    private final int MAX_SEQ_LEN = 5;
    private final int MAX_SEED_LEN = 10;
    
    private final int FRM_PASSPHRASE = 0;
    private final int FRM_SETTINGS = 1;

    private int curFrm;
    private int seqNo;

    private Display dpy;
    private Form frmPassphrase, frmSettings, frmOutput;
    
    private TextField txtPassphrase, txtSeed, txtSeqNo;
    private StringItem strOutput;

    private String seed;
    
    private Command cmdGenerate = new Command("Generate", Command.OK, 1);
    private Command cmdSettings = new Command("Settings", Command.OK, 2);
    private Command cmdPassphrase = new Command("Passphrase", Command.OK, 3);
    private Command cmdExit = new Command("Exit", Command.CANCEL, 4);
    
    public Paranoia()
    {
	dpy = Display.getDisplay(this);
	buildUI();
	curFrm = 0;
    }

    private void buildUI()
    {
	frmPassphrase = new Form("Paranoia");
	frmSettings = new Form("Paranoia");
	frmOutput = new Form("Paranoia");
	
	txtPassphrase = new TextField("Passphrase", "", MAX_PASSPHRASE_LEN, TextField.PASSWORD);
	txtSeed = new TextField("Seed", "", MAX_SEED_LEN,
				TextField.ANY | TextField.NON_PREDICTIVE);
	txtSeqNo = new TextField("Sequence number", "", MAX_SEQ_LEN, TextField.NUMERIC);
	strOutput = new StringItem("", "");
	
	frmPassphrase.append(txtPassphrase);
	frmPassphrase.addCommand(cmdGenerate);
	frmPassphrase.addCommand(cmdSettings);
	frmPassphrase.addCommand(cmdExit);
	frmPassphrase.setCommandListener(this);
	
	frmSettings.append(txtSeqNo);
	frmSettings.append(txtSeed);
	frmSettings.addCommand(cmdPassphrase);
	frmSettings.addCommand(cmdExit);
	frmSettings.setCommandListener(this);
	
	frmOutput.append(strOutput);
	frmOutput.addCommand(cmdExit);
	frmOutput.setCommandListener(this);
    }

    public void destroyApp(boolean what)
    {
    }

    public void pauseApp()
    {
    }
    
    public void startApp()
    {
	if(curFrm == 0)
	    dpy.setCurrent(frmSettings);
	else
	    dpy.setCurrent(frmPassphrase);
    }

    public boolean storeData()
    {
	try {
	    seqNo = Integer.parseInt(txtSeqNo.getString());
	} catch (Exception e) {
	    dpy.setCurrent(new Alert("Paranoia", "Invalid sequence number",
				     null, AlertType.INFO),
			   frmSettings);
	    return false;
	}

	seed = txtSeed.getString();
	if(seed.length() == 0)
	    {
		dpy.setCurrent(new Alert("Paranoia", "Invalid seed",
					 null, AlertType.INFO),
			       frmSettings);
		return false;
	    }
	
	return true;
    }

    public void updateTitle()
    {
	String t;

	t = seqNo + " " + seed + "/MD5";
	frmPassphrase.setTitle(t);
	frmOutput.setTitle(t);
    }

    public void commandAction(Command c, Displayable d)
    {
	if(c == cmdExit)
	    {
		destroyApp(false);
		notifyDestroyed();
	    }

	if(c == cmdSettings)
	    {
		dpy.setCurrent(frmSettings);
		curFrm = 0;
	    }
	
	if(c == cmdPassphrase)
	    {
		if(storeData() == false)
		    return;
		
		updateTitle();
		dpy.setCurrent(frmPassphrase);
		curFrm = 1;
	    }

	if(c == cmdGenerate)
	    {
		strOutput.setText("Computing...");
		dpy.setCurrent(frmOutput);

		new ComputeThread(seqNo, seed, txtPassphrase.getString(), this).start();
	    }
    }

    public synchronized void clean()
    {
	frmPassphrase = null;
	frmSettings = null;
	txtPassphrase = null;
	txtSeed = null;
	txtSeqNo = null;
	seed = null;
	cmdGenerate = null;
	cmdSettings = null;
	cmdPassphrase = null;
    }

    public synchronized void updateText(String s)
    {
	strOutput.setText(s);
	dpy.setCurrent(frmOutput);
    }
}
